﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine.Events;
using UnityEngine;

public class CollisionSound : MonoBehaviour {

    
    public AudioClip collideSoundClip;
    //public UnityEvent<float> onCollide;
    // Use this for initialization
    AudioSource collideSource;
    [System.Serializable]
    public class AdvancedSettings
    {
        [HideInInspector]
        public CollisionSound parent;

        public float volumeScale = 10;
        [Range(0,1)]
        public float spatialBlend = 0;

    }
    public AdvancedSettings advanced;


    private void Awake()
    {
        advanced.parent = this;

        GameObject soundChild = new GameObject("sound child");
        soundChild.transform.parent = this.transform;
        soundChild.transform.localPosition = Vector3.zero;
        soundChild.transform.localRotation = Quaternion.identity;

        this.collideSource = soundChild.AddComponent<AudioSource>();
        
        this.collideSource.playOnAwake = false;
        this.collideSource.loop = false;
    }

    private void OnCollisionEnter(Collision collision)
    {
        //max speed was about 8
        //onCollide.Invoke(collision.relativeVelocity.magnitude);
        //Debug.Log(collision.relativeVelocity.magnitude);
        float volume = (collision.relativeVelocity.sqrMagnitude / 70) *  (advanced.volumeScale * .1f);
        this.collideSource.PlayOneShot(collideSoundClip, volume);
        //collideClip
    }

    private void Update()
    {
        this.collideSource.spatialBlend = advanced.spatialBlend;
    }
}
