﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class VRScreenRecordingHelper : MonoBehaviour {

    //[SerializeField]
    Transform hmdTransform;

    float guiTimeOut = float.NegativeInfinity;

	// Use this for initialization
	void Start ()
    {
        Camera cam = this.GetComponent<Camera>();
        
        //recording camera should on top of Vive camera (in the window, won't affect visuals in headset)
        cam.depth = 100;

        //turn off automatic headset following for this camera, (automatic has a weird offset)
        
        cam.stereoTargetEye = StereoTargetEyeMask.None;
        
	}
	
	void LateUpdate () {
		if (hmdTransform != null)
        {
            //make this recording camera follow the headset exactly
            this.transform.position = hmdTransform.position;
            this.transform.rotation = hmdTransform.rotation;
        }
        else
        {
            //Find the headset transform to follow
            hmdTransform = VRTK.VRTK_DeviceFinder.DeviceTransform(VRTK.VRTK_DeviceFinder.Devices.Headset);
        }
	}

    void OnGUI()
    {
        float guiTimeoutDur = 3;
       if (Input.GetKey(KeyCode.UpArrow))
        {
            this.GetComponent<Camera>().fieldOfView += Time.deltaTime * 4;
            guiTimeOut = Time.time + guiTimeoutDur;
        }
       else if (Input.GetKey(KeyCode.DownArrow))
        {
            this.GetComponent<Camera>().fieldOfView -= Time.deltaTime * 4;
            guiTimeOut = Time.time + guiTimeoutDur;
        }

       if (Time.time < guiTimeOut)
        {
            GUIStyle style = new GUIStyle();
            style.fontSize = 24;
            style.normal.textColor = Color.magenta;
            GUI.Label(new Rect( Screen.width/2,  Screen.height/2, 300, 50), "FOV : " + Mathf.Round(this.GetComponent<Camera>().fieldOfView), style);
        }
       
    }
}
